<?php
/*
Plugin Name: WP Translitera
Plugin URI: http://yur4enko.com/category/moi-proekty/wp-translitera
Description: Plug-in for transliteration permanent permalink records , pages, and tag
Version: 150808
Author: Evgen Yurchenko
Author URI: http://yur4enko.com/
*/

/*  Copyright 2015 Evgen Yurchenko  (email: evgen@yur4enko.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc.
*/

class wp_translitera {
    public static function transliterate($title) {//wp=>0.0.0 php=>5.2.4
        $to = array(
            'А'=>'A','а'=>'a','Б'=>'B','б'=>'b','В'=>'V','в'=>'v','Г'=>'G',
            'г'=>'g','Д'=>'D','д'=>'d','Е'=>'E','е'=>'e','Ё'=>'Jo','ё'=>'jo',
            'Ж'=>'Zh','ж'=>'zh','З'=>'Z','з'=>'z','И'=>'I','и'=>'i','Й'=>'J',
            'й'=>'j','К'=>'K','к'=>'k','Л'=>'L','л'=>'l','М'=>'M','м'=>'m',
            'Н'=>'N','н'=>'n','О'=>'O','о'=>'o','П'=>'P','п'=>'p','Р'=>'R',
            'р'=>'r','С'=>'S','с'=>'s','Т'=>'T','т'=>'t','У'=>'U','у'=>'u',
            'Ф'=>'F','ф'=>'f','Х'=>'H','х'=>'h','Ц'=>'C','ц'=>'c','Ч'=>'Ch',
            'ч'=>'ch','Ш'=>'Sh','ш'=>'sh','Щ'=>'Shh','щ'=>'shh','Ъ'=>'',
            'ъ'=>'','Ы'=>'Y','ы'=>'y','Ь'=>'','ь'=>'','Э'=>'Je','э'=>'je',
            'Ю'=>'Ju','ю'=>'ju','Я'=>'Ja','я'=>'ja'
        );
        return strtr($title, $to);
    }
    
    public static function add_menu(){//wp=>1.5.0 php=>5.2.4
        add_options_page('WP Translitera', 'Translitera', 'activate_plugins', __FILE__, array('wp_translitera','main_settings'));
    }
    
    public static function GetForm() {//wp=>0.0.0 php=>5.2.4
        $ret = '<h2>Настройки:</h2></br>'
                . '<form method=POST> '
                . '<input type="checkbox" name="r1" value="1">Страницы и посты<br></br>'
                . '<input type="checkbox" name="r2" value="1">Рубрики теги и тд<br></br>'
                . '<input type="submit" value="Транслитерировать" name="apply"></form>';
        return $ret;                
    }
    
    public static function do_transliterte($table,$id,$name) {//wp=>0.71 php=>5.2.4
        global $wpdb;
        $rez = $wpdb->get_results("SELECT {$id}, {$name} FROM {$table} WHERE 1",ARRAY_A);
        foreach ($rez as $value) {
            $tmp_name = wp_translitera::transliterate(urldecode($value[$name]));
            if ($tmp_name != $value[$name]) {
                $wpdb->update($table,array($name=>$tmp_name),array($id=>$value[$id]));
            }
        }
    }

    public static function main_settings() {//wp=>0.71 php=>5.2.4
        global $wpdb;
        $act = filter_input(INPUT_POST,'apply');
        if (!empty($act)) {
            $r1 = filter_input(INPUT_POST, 'r1');
            $r2 = filter_input(INPUT_POST, 'r2');
            if (!empty($r1)) {
                wp_translitera::do_transliterte($wpdb->posts, 'ID', 'post_name');
                //$rez = $wpdb->get_results("SELECT ID, post_name FROM {$wpdb->posts} WHERE 1",ARRAY_A);
                //foreach ($rez as $value) {
                //    $wpdb->update($wpdb->posts,array('post_name'=>wp_translitera::prepare_cont($value['post_name'])),array('ID'=>$value['ID']));
                //}
            }
            if (!empty($r2)){
                wp_translitera::do_transliterte($wpdb->terms, 'term_id', 'slug');
                //$rez = $wpdb->get_results("SELECT term_id, slug FROM {$wpdb->terms} WHERE 1",ARRAY_A);
                //foreach ($rez as $value) {
                //    $wpdb->update($wpdb->terms,array('slug'=>wp_translitera::prepare_cont($value['slug'])),array('term_id'=>$value['term_id']));
                //}
            }
            
        } 
        echo wp_translitera::GetForm();
    }
}

//wp=>1.5.2 php=>5.2.4
add_action('sanitize_title', array('wp_translitera','transliterate'), 0);
add_action('admin_menu', array('wp_translitera', 'add_menu'));